Subject: Re: rsync 3.0.4 over ssh hanging on cygwin 1.7
From: "Brett Serkez" <[email-masked]>
To: [email-masked]
Cc: "G.W. Haywood" <[email-masked]>
Date: Wed, 19 Nov 2008 07:24:33 -0500
List-Id: <cygwin.cygwin.com>

On Wed, Nov 19, 2008 at 6:54 AM, Fred Kemp <[email-masked]> wrote:
> Hi Ged,
>
> Thanks for the info, due to being on a University campus, we are restricted
> in what we are allowed to set up and VPN's are one of those explicitly
> mentioned :-( However, since OsX has a built in VPN server, I will perhaps
> have a covert test of this if I can get rsyncd to play nice.

Not that I would advocate violating policy, but OpenVPN can establish
a connections over TCP (UDP is the default),  OpenVPN should be able
to establish a TCP connection over port 443 and thus be
indistinguishable from a https connection.

Another alternative is to use a virtual Linux host running under
something like VirtualBox on your Windows host.  VirtualBox should be
able to expose the relevant portion of your local file system to the
virtual Linux host which can then run rsync over ssh.

>
> In the meantime, if anyone has any ideas as to where the problem lies, I
> would be willing to spend some time investigating it further. It does seem
> to be a longstanding issue, with posts as far back as 2002 and as recent as
> last month on the subject.

I spent considerable time on this and reported were the problem is
occurring to no avail, don't waste your time.  In a nutshell the issue
is with Cygwin's bi-directional pipe emulation, this is a fundamental
feature of all UNIXies.  Secure Shell "forks and execs" rsync,
connecting standard out and in so that data flows over the internet
to/from SSH and then locally to/from rsync.  The problem is that
eventually a "signal" is missed and SSH and rsync deadlock, the local
pipe emulation is imperfect, and the rsync protocol has no provision
to recover from this dead lock.

A fix would require a change to this fundamental feature of Cygwin, it
is not clear to me that Windows has the necessary functionality to
properly implement, such a fix would require extensive retesting.

Brett

--
Unsubscribe info:      http://cygwin.com/ml/#unsubscribe-simple
Problem reports:       http://cygwin.com/problems.html
Documentation:         http://cygwin.com/docs.html
FAQ:                   http://cygwin.com/faq/